apiVersion: operator.victoriametrics.com/v1beta1
kind: VMRule
metadata:
  annotations:
    meta.helm.sh/release-name: vm-cluster
    meta.helm.sh/release-namespace: monitoring
  labels:
    app: victoria-metrics-k8s-stack
    app.kubernetes.io/instance: vm-cluster
    app.kubernetes.io/managed-by: Helm
    app.kubernetes.io/name: victoria-metrics-k8s-stack
    app.kubernetes.io/version: 1.86.2
    helm.sh/chart: victoria-metrics-k8s-stack-0.14.5
  name: istio.rules
  namespace: monitoring
spec:
  groups:
  - name: Istio
    rules:
    - alert: '[Istio-Citadel] CSR without success'
      expr: |
        rate(citadel_server_csr_count[5m]) - rate(citadel_server_success_cert_issuance_count[5m]) > 0
      for: 5m
      labels:
        severity: warning
      annotations:
        summary: "Some of the Certificate Signing Requests (CSR) were not correctly requested."
        description: Some of the Certificate Signing Requests (CSR) were not correctly requested.
    - alert: '[Istio-Pilot] Inbound listener rules conflicts'
      expr: |
        pilot_conflict_inbound_listener > 0
      for: 5m
      labels:
        severity: warning
      annotations:
        summary: "There are some conflicts with inbound listener rules."
        description: There are some conflicts with inbound listener rules.
    - alert: '[Istio-Pilot] Endpoint found in unready state'
      expr: |
        pilot_endpoint_not_ready > 0
      for: 5m
      labels:
        severity: warning
      annotations:
        summary: "Endpoint found in unready state."
        description: Endpoint found in unready state.
    - alert: '[Istio] Unstable requests for sidecar injections'
      expr: |
        rate(sidecar_injection_requests_total[5m]) - rate(sidecar_injection_success_total[5m]) > 0
      for: 5m
      labels:
        severity: warning
      annotations:
        summary: "Sidecar injections requests are failing."
        description: Sidecar injections requests are failing.
    - alert: '[Istio-Envoy] High 4xx RequestError Rate'
      expr: |
        sum (rate(istio_requests_total{ response_code=~"4..", reporter="source"}[5m]))/ sum (rate(istio_requests_total{ reporter="source"}[5m]))> 0.05
      for: 5m
      labels:
        severity: critical
      annotations:
        summary: "4xx RequestError Rate is higher than 20%."
        description: 4xx RequestError Rate is higher than 20%.
    - alert: '[Istio-Envoy] High 5xx RequestError Rate'
      expr: |
        sum (rate(istio_requests_total{ response_code=~"5..", reporter="source"}[5m]))/ sum (rate(istio_requests_total{ reporter="source"}[5m]))> 0.20
      for: 5m
      labels:
        severity: critical
      annotations:
        summary: "5xx RequestError Rate is higher than 5%."
        description: 5xx RequestError Rate is higher than 5%.
    - alert: '[Istio-Envoy] High Request Latency'
      expr: |
        histogram_quantile(0.95,sum(rate(envoy_cluster_upstream_cx_connect_ms_bucket[5m])) by (le)) > 100
      for: 5m
      labels:
        severity: critical
      annotations:
        summary: "Envoy Request Latency is higher than 100ms."
        description: Envoy Request Latency is higher than 100ms.